---
title: Update WhatsApp Content
description: This example uses PUT {{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}} to update notification content for a WhatsApp message for device pairing.
component: pingone-api
page_id: pingone-api:platform:notifications/notifications-templates/update_whatsapp_content
canonical_url: https://developer.pingidentity.com/pingone-api/platform/notifications/notifications-templates/update_whatsapp_content.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Update WhatsApp Content

##

```none
PUT {{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}
```

This example uses `PUT {{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}` to update notification content for a WhatsApp message for device pairing.

The URL includes the template for which the content is being updated, in this case `device_pairing`. For more information, refer to [Notifications Templates](../notifications-templates.html).

The URL also includes the ID of the specific content element that is being updated.

The body of the request includes the `whatsAppTemplate` object which contains the necessary information for identifying the WhatsApp template that should be used for the content.

Use `{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp?expand=whatsAppTemplates` to get a list of all the available WhatsApp templates, as shown in the [Read WhatsApp Delivery Settings (including templates)](../instant-messaging-delivery-settings/read_whatsapp_delivery_settings_including_templates.html) example.

### Prerequisites

* Refer to [Notifications](../../notifications.html) for important overview information.

> **Collapse: Request Model**
>
> | Property                    | Type   | Required? |
> | --------------------------- | ------ | --------- |
> | `deliveryMethod`            | String | Required  |
> | `locale`                    | String | Required  |
> | `whatsAppTemplate`          | Object | Required  |
> | `whatsAppTemplate.id`       | String | Required  |
> | `whatsAppTemplate.name`     | String | Required  |
> | `whatsAppTemplate.category` | String | Required  |
> | `whatsAppTemplate.language` | String | Required  |
>
> Refer to the [Content Properties data model](../notifications-templates.html#notifications-templates-content-properties) for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "deliveryMethod": "WhatsApp",
    "locale": "fr-FR",
    "whatsAppTemplate": {
        "id": "2223282941382315",
        "name": "device_pairing____15",
        "category": "AUTHENTICATION",
        "language": "fr"
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "deliveryMethod": "WhatsApp",
    "locale": "fr-FR",
    "whatsAppTemplate": {
        "id": "2223282941382315",
        "name": "device_pairing____15",
        "category": "AUTHENTICATION",
        "language": "fr"
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""deliveryMethod"": ""WhatsApp""," + "\n" +
@"    ""locale"": ""fr-FR""," + "\n" +
@"    ""whatsAppTemplate"": {" + "\n" +
@"        ""id"": ""2223282941382315""," + "\n" +
@"        ""name"": ""device_pairing____15""," + "\n" +
@"        ""category"": ""AUTHENTICATION""," + "\n" +
@"        ""language"": ""fr""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}"
  method := "PUT"

  payload := strings.NewReader(`{
    "deliveryMethod": "WhatsApp",
    "locale": "fr-FR",
    "whatsAppTemplate": {
        "id": "2223282941382315",
        "name": "device_pairing____15",
        "category": "AUTHENTICATION",
        "language": "fr"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "deliveryMethod": "WhatsApp",
    "locale": "fr-FR",
    "whatsAppTemplate": {
        "id": "2223282941382315",
        "name": "device_pairing____15",
        "category": "AUTHENTICATION",
        "language": "fr"
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"deliveryMethod\": \"WhatsApp\",\n    \"locale\": \"fr-FR\",\n    \"whatsAppTemplate\": {\n        \"id\": \"2223282941382315\",\n        \"name\": \"device_pairing____15\",\n        \"category\": \"AUTHENTICATION\",\n        \"language\": \"fr\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "deliveryMethod": "WhatsApp",
    "locale": "fr-FR",
    "whatsAppTemplate": {
      "id": "2223282941382315",
      "name": "device_pairing____15",
      "category": "AUTHENTICATION",
      "language": "fr"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "deliveryMethod": "WhatsApp",
    "locale": "fr-FR",
    "whatsAppTemplate": {
      "id": "2223282941382315",
      "name": "device_pairing____15",
      "category": "AUTHENTICATION",
      "language": "fr"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}"

payload = json.dumps({
  "deliveryMethod": "WhatsApp",
  "locale": "fr-FR",
  "whatsAppTemplate": {
    "id": "2223282941382315",
    "name": "device_pairing____15",
    "category": "AUTHENTICATION",
    "language": "fr"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "deliveryMethod": "WhatsApp",\n    "locale": "fr-FR",\n    "whatsAppTemplate": {\n        "id": "2223282941382315",\n        "name": "device_pairing____15",\n        "category": "AUTHENTICATION",\n        "language": "fr"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "deliveryMethod": "WhatsApp",
  "locale": "fr-FR",
  "whatsAppTemplate": {
    "id": "2223282941382315",
    "name": "device_pairing____15",
    "category": "AUTHENTICATION",
    "language": "fr"
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"deliveryMethod\": \"WhatsApp\",\n    \"locale\": \"fr-FR\",\n    \"whatsAppTemplate\": {\n        \"id\": \"2223282941382315\",\n        \"name\": \"device_pairing____15\",\n        \"category\": \"AUTHENTICATION\",\n        \"language\": \"fr\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/device_pairing/contents/a1de12bb-0649-4f06-ae13-528ef7371f32"
        },
        "template": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/device_pairing"
        },
        "environment": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "id": "a1de12bb-0649-4f06-ae13-528ef7371f32",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2025-03-23T16:04:15.650Z",
    "updatedAt": "2025-03-23T16:20:26.389Z",
    "locale": "fr-FR",
    "template": {
        "id": "device_pairing"
    },
    "deliveryMethod": "WhatsApp",
    "whatsAppTemplate": {
        "id": "2223282941382315",
        "name": "device_pairing____15",
        "category": "AUTHENTICATION",
        "language": "fr"
    },
    "default": false
}
```
